package me.Demon.DemonShiTu.guimanager;

import me.Demon.Compat.VexCompatGui;
import me.Demon.DemonLevels.api.DLevelAPI;
import me.Demon.DemonOnlineTime.DtimeAPI;
import me.Demon.DemonPlugin.DemonAPI;
import me.Demon.DemonShiTu.Main;
import me.Demon.DemonShiTu.ShiTuAPI;
import me.Demon.DemonShiTu.data.ShiFuData;
import me.Demon.DemonShiTu.manager.DataManager;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.ArrayList;
import java.util.List;

public class LookDataGui implements Listener {

    public static String invTitle = "师徒系统 - 查看所有师傅数据";

    @EventHandler
    public void onClick(InventoryClickEvent e){
        Player p = (Player) e.getWhoClicked();
        Inventory inv = e.getInventory();
        int rawSlot = e.getRawSlot();
        ItemStack item = e.getCurrentItem();
        if(inv != null && inv.getTitle().equalsIgnoreCase(invTitle)){
            e.setCancelled(true);
        }
    }

    public static void OpenGui(Player player){
        Inventory inv = Bukkit.createInventory(null,54,invTitle);
        for (int i = 0; i < 9; i++) {
            inv.setItem(i, DemonAPI.glass(15,"§a§l↓↓§6已出师的玩家列表§a§l↓↓"));
        }
        DataManager dataManager = Main.dataManager;
        for (String sfName : dataManager.getShiFuDataMap().keySet()){
            ShiFuData shiFuData = dataManager.getTeacherData(sfName);
            inv.addItem(ShiFuSkull(shiFuData));
        }
        for (int i = 45; i < 54; i++) {
            inv.setItem(i, DemonAPI.glass(15,"§a§l↑↑§6已出师的玩家列表§a§l↑↑"));
        }
        player.openInventory(inv);
    }

    public static ItemStack ShiFuSkull(ShiFuData fuData){
        String sfName = fuData.getName();
        ItemStack item = new ItemStack(Material.BOOK);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§b§l★§7名称: §6§l"+fuData.getName());
        List<String> lore = new ArrayList<>();
        int levels = (int) DLevelAPI.getOffPlayer_Level(sfName);
        lore.add("§a§l★§7级别: §dLv."+ levels);
        int time = DtimeAPI.getTime(sfName);
        lore.add("§a§l★§7今日活跃: §a"+ time+"分钟");
        lore.add("§a§l★§7本月收益: §6" + String.format("%.1f",fuData.getEarnings()) + "师徒币");
        lore.add("§a§l★§7收徒数量: §e" + fuData.getTudiList().size() + "名");
        int top = VexCompatGui.getTop_self(sfName);
        lore.add("§a§l★§7战力排行: §b" + top + "名");
        lore.add("§a§l★§7经验加成: §d"+ShiTuAPI.getExpDouble(sfName)+"%");
        lore.add("§a§l★§7最后一次上线: §c"+DemonAPI.LongToStringData(fuData.getLoginTime(),"yyyy年MM月dd日 HH:mm"));
        lore.add(" ");
        lore.add("§9§l★ §6SHIFT+左键 §7点击结算他的收益");
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }
}
