package me.Demon.DemonShiTu.listener;

import me.Demon.DemonShiTu.Main;
import me.Demon.DemonShiTu.ShiTuAPI;
import me.Demon.DemonShiTu.manager.DataManager;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerChangedWorldEvent;
import org.bukkit.event.player.PlayerQuitEvent;
import org.serverct.ersha.jd.AttributeAPI;

import java.util.ArrayList;
import java.util.List;

public class AttributeLoad implements Listener {

    @EventHandler
    public void loadApStats(PlayerChangedWorldEvent e) {
        Player p = e.getPlayer();
        String name = p.getName();
        // 判断玩家是否有师傅
        DataManager dataManager = Main.dataManager;
        if (dataManager.isPlayerExitTeacher(name)) {
            if(p.getLevel() <= 85) {
                String sfName = dataManager.getTeacherName(name);
                if(ShiTuAPI.getExpDouble(sfName) >= 1) {
                    List<String> apStats = new ArrayList<>();
                    apStats.add("经验加成: " + ShiTuAPI.getExpDouble(sfName) + "%");
                    AttributeAPI.addAttribute(p, "师徒_ApStats", apStats);
                }
            }
        }
    }

    @EventHandler
    public void onquit(PlayerQuitEvent e) {
        Player p = e.getPlayer();
        String name = p.getName();
        // 判断玩家是否有师傅
        DataManager dataManager = Main.dataManager;
        if (dataManager.isPlayerExitTeacher(name)) {
            if(p.getLevel() <= 85) {
                AttributeAPI.deleteAttribute(p, "师徒_ApStats");
            }
        }
    }
}
