package me.Demon.DemonShiTu.util;

import net.minecraft.server.v1_12_R1.NBTTagCompound;
import org.bukkit.Material;
import org.bukkit.craftbukkit.v1_12_R1.inventory.CraftItemStack;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.ArrayList;
import java.util.List;

public class StackLibrary{

    public static NBTTagCompound getNBT(ItemStack Equipment) {
        net.minecraft.server.v1_12_R1.ItemStack nmsEquipment = CraftItemStack.asNMSCopy(Equipment);
        return nmsEquipment.hasTag() && nmsEquipment.getTag() != null ? nmsEquipment.getTag() : new NBTTagCompound();
    }

    public static ItemStack setNBT(ItemStack item, NBTTagCompound nbtEquipment) {
        net.minecraft.server.v1_12_R1.ItemStack nmsEquipment = CraftItemStack.asNMSCopy(item);
        nmsEquipment.setTag(nbtEquipment);
        return CraftItemStack.asBukkitCopy(nmsEquipment);
    }

    public static ItemStack tudiInfoShow(){
        ItemStack item = new ItemStack(Material.PAPER);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§6§l师徒激励计划§6玩法介绍");
        List<String> lore = new ArrayList<>();
        lore.add("§a§l★§7师傅 = §a玩家A");
        lore.add("§a§l★§7徒弟 = §b玩家B");
        lore.add("§d§l★§7师徒系统经验加成参考: ");
        lore.add("§7- [§a玩家A§7]战力排行§e第一名§7，[§b玩家B§7]可获: §d经验加成50% §r");
        lore.add("§7- [§a玩家A§7]战力排行§e前三名§7，[§b玩家B§7]可获: §d经验加成30%");
        lore.add("§7- [§a玩家A§7]战力排行§e前六名§7，[§b玩家B§7]可获: §d经验加成20%");
        lore.add("§7- [§a玩家A§7]战力排行§e前十名§7，[§b玩家B§7]可获: §d经验加成10%");
        lore.add("§7- [§a玩家A§7]战力排行§e前30名§7，[§b玩家B§7]可获: §d经验加成5%");
        lore.add("§c温馨提示:§b徒弟的等级大于90级后将不享有经验加成。");
        meta.setLore(lore);
        item.setItemMeta(meta);
        NBTTagCompound nbti = getNBT(item);
        nbti.setString("stex","cailiao_124");
        return setNBT(item, nbti);
    }

    public static ItemStack teacherInfoShow(){
        ItemStack item = new ItemStack(Material.PAPER);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§6§l师徒激励计划§6玩法介绍");
        List<String> lore = new ArrayList<>();
        lore.add("§a§l★§7师傅 = §a玩家A");
        lore.add("§a§l★§7徒弟 = §b玩家B");
        lore.add("§a§l★§7徒弟的徒弟 = §c玩家C");
        lore.add("§d§l★§7玩法大致介绍: ");
        lore.add("§7- [§b玩家B§7]拜[§a玩家A§7]为师傅，然后[§b玩家B§7]每日§3在线游玩3小时§7以上");
        lore.add("§7- [§a玩家A§7]就能获得§620的师徒币§7作为奖励，若[§b玩家B§7]有任意充值");
        lore.add("§7- [§a玩家A§7]还能获得§e20%的等价师徒币§7作为奖励，依次类推[§c玩家C§7]");
        lore.add("§7- 拜玩家[§b玩家B§7]为师当[§b玩家B§7]获得收益的时候，[§a玩家A§7]可获取");
        lore.add("§7- [§b玩家B§7]收益的§e50%§7作为§6激励计划§7平分收益，若§4解除师徒§7关系");
        lore.add("§7- [§b玩家B§7]将不再与[§a玩家A§7§7]平分§6激励计划§7的收益。");
        lore.add("§7- 每周一至周五师徒币会额外增加§e[30%]§7的收益。");
        lore.add("§d§l✪§7此系统正在测试阶段,若有意见可向客服反馈.");
        meta.setLore(lore);
        item.setItemMeta(meta);
        NBTTagCompound nbti = getNBT(item);
        nbti.setString("stex","cailiao_124");
        return setNBT(item, nbti);
    }
    public static ItemStack Back_book(){
        ItemStack item = new ItemStack(340);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("   §8« §e返回主页 §8»");
        List<String> lore = new ArrayList<>();
        lore.add("§a§l★ §7返回师徒主页 §a§l★");
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }
}
